var NAVTREE =
[
  [ "RobOptim core library", "index.html", [
    [ "User manual", "index.html", [
      [ "Quick start", "quickstart.html", null ],
      [ "Frequently Asked Questions (FAQ)", "faq.html", null ],
      [ "Design choices and libraries' internals", "design.html", null ],
      [ "How to link the library with a new solver?", "bridge.html", null ]
    ] ],
    [ "Modules", "modules.html", [
      [ "Mathematical abstract functions", "group__roboptim__meta__function.html", null ],
      [ "Mathematical functions", "group__roboptim__function.html", null ],
      [ "Optimization problems", "group__roboptim__problem.html", null ],
      [ "Optimization solvers", "group__roboptim__solver.html", null ],
      [ "Visualization", "group__roboptim__visualization.html", null ]
    ] ],
    [ "Class List", "annotated.html", [
      [ "roboptim::BadGradient", "classroboptim_1_1BadGradient.html", null ],
      [ "roboptim::visualization::gnuplot::Command", "classroboptim_1_1visualization_1_1gnuplot_1_1Command.html", null ],
      [ "roboptim::ConstantFunction", "classroboptim_1_1ConstantFunction.html", null ],
      [ "roboptim::DerivableFunction", "classroboptim_1_1DerivableFunction.html", null ],
      [ "roboptim::DerivableParametrizedFunction< F >", "classroboptim_1_1DerivableParametrizedFunction.html", null ],
      [ "roboptim::DummySolver", "classroboptim_1_1DummySolver.html", null ],
      [ "roboptim::FiniteDifferenceGradient< FdgPolicy >", "classroboptim_1_1FiniteDifferenceGradient.html", null ],
      [ "roboptim::finiteDifferenceGradientPolicies::FivePointsRule", "structroboptim_1_1finiteDifferenceGradientPolicies_1_1FivePointsRule.html", null ],
      [ "roboptim::Function", "classroboptim_1_1Function.html", null ],
      [ "roboptim::GenericSolver", "classroboptim_1_1GenericSolver.html", null ],
      [ "roboptim::visualization::Gnuplot", "classroboptim_1_1visualization_1_1Gnuplot.html", null ],
      [ "roboptim::IdentityFunction", "classroboptim_1_1IdentityFunction.html", null ],
      [ "roboptim::LinearFunction", "classroboptim_1_1LinearFunction.html", null ],
      [ "roboptim::NoSolution", "classroboptim_1_1NoSolution.html", null ],
      [ "roboptim::NTimesDerivableFunction< DerivabilityOrder >", "classroboptim_1_1NTimesDerivableFunction.html", null ],
      [ "roboptim::NTimesDerivableFunction< 2 >", "classroboptim_1_1NTimesDerivableFunction_3_012_01_4.html", null ],
      [ "roboptim::NumericLinearFunction", "classroboptim_1_1NumericLinearFunction.html", null ],
      [ "roboptim::NumericQuadraticFunction", "classroboptim_1_1NumericQuadraticFunction.html", null ],
      [ "roboptim::ParametrizedFunction< F >", "classroboptim_1_1ParametrizedFunction.html", null ],
      [ "roboptim::Problem< F, CLIST >", "classroboptim_1_1Problem.html", null ],
      [ "roboptim::QuadraticFunction", "classroboptim_1_1QuadraticFunction.html", null ],
      [ "roboptim::Result", "classroboptim_1_1Result.html", null ],
      [ "roboptim::ResultWithWarnings", "classroboptim_1_1ResultWithWarnings.html", null ],
      [ "roboptim::finiteDifferenceGradientPolicies::Simple", "structroboptim_1_1finiteDifferenceGradientPolicies_1_1Simple.html", null ],
      [ "roboptim::Solver< F, C >", "classroboptim_1_1Solver.html", null ],
      [ "roboptim::SolverError", "classroboptim_1_1SolverError.html", null ],
      [ "roboptim::SolverFactory< T >", "classroboptim_1_1SolverFactory.html", null ],
      [ "roboptim::SolverWarning", "classroboptim_1_1SolverWarning.html", null ],
      [ "roboptim::TwiceDerivableFunction", "classroboptim_1_1TwiceDerivableFunction.html", null ]
    ] ],
    [ "Class Index", "classes.html", null ],
    [ "Class Hierarchy", "hierarchy.html", [
      [ "roboptim::BadGradient", "classroboptim_1_1BadGradient.html", null ],
      [ "roboptim::visualization::gnuplot::Command", "classroboptim_1_1visualization_1_1gnuplot_1_1Command.html", null ],
      [ "roboptim::finiteDifferenceGradientPolicies::FivePointsRule", "structroboptim_1_1finiteDifferenceGradientPolicies_1_1FivePointsRule.html", null ],
      [ "roboptim::Function", "classroboptim_1_1Function.html", [
        [ "roboptim::DerivableFunction", "classroboptim_1_1DerivableFunction.html", [
          [ "roboptim::FiniteDifferenceGradient< FdgPolicy >", "classroboptim_1_1FiniteDifferenceGradient.html", null ],
          [ "roboptim::TwiceDerivableFunction", "classroboptim_1_1TwiceDerivableFunction.html", [
            [ "roboptim::NTimesDerivableFunction< 2 >", "classroboptim_1_1NTimesDerivableFunction_3_012_01_4.html", null ],
            [ "roboptim::QuadraticFunction", "classroboptim_1_1QuadraticFunction.html", [
              [ "roboptim::LinearFunction", "classroboptim_1_1LinearFunction.html", [
                [ "roboptim::ConstantFunction", "classroboptim_1_1ConstantFunction.html", null ],
                [ "roboptim::IdentityFunction", "classroboptim_1_1IdentityFunction.html", null ],
                [ "roboptim::NumericLinearFunction", "classroboptim_1_1NumericLinearFunction.html", null ]
              ] ],
              [ "roboptim::NumericQuadraticFunction", "classroboptim_1_1NumericQuadraticFunction.html", null ]
            ] ]
          ] ]
        ] ]
      ] ],
      [ "roboptim::GenericSolver", "classroboptim_1_1GenericSolver.html", [
        [ "roboptim::Solver< F, C >", "classroboptim_1_1Solver.html", null ],
        [ "roboptim::Solver< Function, boost::mpl::vector< Function > >", "classroboptim_1_1Solver.html", [
          [ "roboptim::DummySolver", "classroboptim_1_1DummySolver.html", null ]
        ] ]
      ] ],
      [ "roboptim::visualization::Gnuplot", "classroboptim_1_1visualization_1_1Gnuplot.html", null ],
      [ "roboptim::NoSolution", "classroboptim_1_1NoSolution.html", null ],
      [ "roboptim::NTimesDerivableFunction< DerivabilityOrder >", "classroboptim_1_1NTimesDerivableFunction.html", null ],
      [ "roboptim::ParametrizedFunction< F >", "classroboptim_1_1ParametrizedFunction.html", [
        [ "roboptim::DerivableParametrizedFunction< F >", "classroboptim_1_1DerivableParametrizedFunction.html", null ]
      ] ],
      [ "roboptim::Problem< F, CLIST >", "classroboptim_1_1Problem.html", null ],
      [ "roboptim::Result", "classroboptim_1_1Result.html", [
        [ "roboptim::ResultWithWarnings", "classroboptim_1_1ResultWithWarnings.html", null ]
      ] ],
      [ "roboptim::finiteDifferenceGradientPolicies::Simple", "structroboptim_1_1finiteDifferenceGradientPolicies_1_1Simple.html", null ],
      [ "roboptim::SolverError", "classroboptim_1_1SolverError.html", [
        [ "roboptim::SolverWarning", "classroboptim_1_1SolverWarning.html", null ]
      ] ],
      [ "roboptim::SolverFactory< T >", "classroboptim_1_1SolverFactory.html", null ]
    ] ],
    [ "Class Members", "functions.html", null ],
    [ "Namespace List", "namespaces.html", [
      [ "roboptim", "namespaceroboptim.html", null ],
      [ "roboptim::finiteDifferenceGradientPolicies", "namespaceroboptim_1_1finiteDifferenceGradientPolicies.html", null ],
      [ "roboptim::visualization", "namespaceroboptim_1_1visualization.html", null ],
      [ "roboptim::visualization::gnuplot", "namespaceroboptim_1_1visualization_1_1gnuplot.html", null ]
    ] ],
    [ "Namespace Members", "namespacemembers.html", null ],
    [ "File List", "files.html", [
      [ "constant-function.cc", "constant-function_8cc.html", null ],
      [ "constant-function.hh", "constant-function_8hh.html", null ],
      [ "debug.cc", "debug_8cc.html", null ],
      [ "include/roboptim/core/debug.hh", "include_2roboptim_2core_2debug_8hh.html", null ],
      [ "src/debug.hh", "src_2debug_8hh.html", null ],
      [ "derivable-function.cc", "derivable-function_8cc.html", null ],
      [ "derivable-function.hh", "derivable-function_8hh.html", null ],
      [ "derivable-parametrized-function.hh", "derivable-parametrized-function_8hh.html", null ],
      [ "doc.hh", "doc_8hh.html", null ],
      [ "dummy.hh", "dummy_8hh.html", null ],
      [ "finite-difference-gradient.cc", "finite-difference-gradient_8cc.html", null ],
      [ "finite-difference-gradient.hh", "finite-difference-gradient_8hh.html", null ],
      [ "finite-difference-gradient.hxx", "finite-difference-gradient_8hxx.html", null ],
      [ "function.cc", "function_8cc.html", null ],
      [ "function.hh", "function_8hh.html", null ],
      [ "fwd.hh", "fwd_8hh.html", null ],
      [ "visualization/fwd.hh", "visualization_2fwd_8hh.html", null ],
      [ "generic-solver.cc", "generic-solver_8cc.html", null ],
      [ "generic-solver.hh", "generic-solver_8hh.html", null ],
      [ "gnuplot-commands.cc", "gnuplot-commands_8cc.html", null ],
      [ "gnuplot-commands.hh", "gnuplot-commands_8hh.html", null ],
      [ "gnuplot-function.hh", "gnuplot-function_8hh.html", null ],
      [ "gnuplot.cc", "gnuplot_8cc.html", null ],
      [ "gnuplot.hh", "gnuplot_8hh.html", null ],
      [ "identity-function.cc", "identity-function_8cc.html", null ],
      [ "identity-function.hh", "identity-function_8hh.html", null ],
      [ "indent.cc", "indent_8cc.html", null ],
      [ "indent.hh", "indent_8hh.html", null ],
      [ "io.hh", "io_8hh.html", null ],
      [ "linear-function.cc", "linear-function_8cc.html", null ],
      [ "linear-function.hh", "linear-function_8hh.html", null ],
      [ "n-times-derivable-function.hh", "n-times-derivable-function_8hh.html", null ],
      [ "n-times-derivable-function.hxx", "n-times-derivable-function_8hxx.html", null ],
      [ "numeric-linear-function.cc", "numeric-linear-function_8cc.html", null ],
      [ "numeric-linear-function.hh", "numeric-linear-function_8hh.html", null ],
      [ "numeric-quadratic-function.cc", "numeric-quadratic-function_8cc.html", null ],
      [ "numeric-quadratic-function.hh", "numeric-quadratic-function_8hh.html", null ],
      [ "parametrized-function.hh", "parametrized-function_8hh.html", null ],
      [ "parametrized-function.hxx", "parametrized-function_8hxx.html", null ],
      [ "portability.hh", "portability_8hh.html", null ],
      [ "problem.hh", "problem_8hh.html", null ],
      [ "problem.hxx", "problem_8hxx.html", null ],
      [ "quadratic-function.cc", "quadratic-function_8cc.html", null ],
      [ "quadratic-function.hh", "quadratic-function_8hh.html", null ],
      [ "result-with-warnings.cc", "result-with-warnings_8cc.html", null ],
      [ "result-with-warnings.hh", "result-with-warnings_8hh.html", null ],
      [ "result.cc", "result_8cc.html", null ],
      [ "result.hh", "result_8hh.html", null ],
      [ "roboptim-core-dummy-plugin.cc", "roboptim-core-dummy-plugin_8cc.html", null ],
      [ "solver-error.cc", "solver-error_8cc.html", null ],
      [ "solver-error.hh", "solver-error_8hh.html", null ],
      [ "solver-factory.hh", "solver-factory_8hh.html", null ],
      [ "solver-factory.hxx", "solver-factory_8hxx.html", null ],
      [ "solver-warning.cc", "solver-warning_8cc.html", null ],
      [ "solver-warning.hh", "solver-warning_8hh.html", null ],
      [ "solver.hh", "solver_8hh.html", null ],
      [ "solver.hxx", "solver_8hxx.html", null ],
      [ "sys.hh", "sys_8hh.html", null ],
      [ "twice-derivable-function.cc", "twice-derivable-function_8cc.html", null ],
      [ "twice-derivable-function.hh", "twice-derivable-function_8hh.html", null ],
      [ "util.cc", "util_8cc.html", null ],
      [ "util.hh", "util_8hh.html", null ],
      [ "util.hxx", "util_8hxx.html", null ]
    ] ],
    [ "Examples", "examples.html", [
      [ "constant-function.cc", "constant-function_8cc-example.html", null ],
      [ "finite-difference-gradient.cc", "finite-difference-gradient_8cc-example.html", null ],
      [ "identity-function.cc", "identity-function_8cc-example.html", null ],
      [ "numeric-linear-function.cc", "numeric-linear-function_8cc-example.html", null ],
      [ "numeric-quadratic-function.cc", "numeric-quadratic-function_8cc-example.html", null ],
      [ "problem-cc.cc", "problem-cc_8cc-example.html", null ],
      [ "result.cc", "result_8cc-example.html", null ],
      [ "visualization-gnuplot-function.cc", "visualization-gnuplot-function_8cc-example.html", null ],
      [ "visualization-gnuplot-simple.cc", "visualization-gnuplot-simple_8cc-example.html", null ]
    ] ],
    [ "File Members", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

